import 'dart:convert';
import 'dart:developer';

import 'package:flutter/material.dart';
import 'package:sample/push_notification_manager.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'package:http/http.dart' as http;
//import 'package:flutter_app_badger/flutter_app_badger.dart';
// ignore: library_prefixes
import 'package:encrypt/encrypt.dart' as EncryptPack;
// ignore: library_prefixes
import 'package:crypto/crypto.dart' as CryptoPack;
//   String vipSec= '7f7798c798956e30b845a19f066bf583';

// String meSec="d766f45c5b7976e170b3e7e751ade0b7";

class HomeScreen extends StatefulWidget {
  HomeScreen({Key? key, this.url});
  final String? url;
  @override
  State<HomeScreen> createState() => HomeScreenState();
}

class HomeScreenState extends State<HomeScreen> with WidgetsBindingObserver {
  final ValueNotifier<bool> _loading = ValueNotifier<bool>(false);
  late WebViewController controller;
  late String url;

//for me
  String keySecret = "d766f45c5b7976e170b3e7e751ade0b7";
//for vip
  // String keySecret = '7f7798c798956e30b845a19f066bf583';
  @override
  void initState() {
    url = widget.url ?? "https://sample.com/";
    WidgetsBinding.instance!.addObserver(this);
    //url = widget.url ?? "https://sample.com/";
    // TODO: implement initState
    super.initState();
  }

  @override
  void dispose() {
    WidgetsBinding.instance!.removeObserver(this);
    super.dispose();
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    switch (state) {
      case AppLifecycleState.resumed:
        /*FlutterAppBadger.isAppBadgeSupported().then((value) {
          if (value) {
            debugPrint('remove badge has been used');
            FlutterAppBadger.removeBadge();
          } else {
            debugPrint('remove badge isnt supported');
          }
        });*/
        break;
      default:
    }
    // TODO: implement didChangeAppLifecycleState
    super.didChangeAppLifecycleState(state);
  }

  // goToUrl(String url) {
  //   controller.loadUrl(url);
  // }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: () async {
        bool canGoBack = await controller.canGoBack();
        if (canGoBack) {
          controller.goBack();
        }

        return false;
      },
      child: SafeArea(
        child: Stack(
          alignment: Alignment.center,
          children: [
            WebView(
              onWebViewCreated: (controller) {
                this.controller = controller;
              },
              javascriptChannels: {
                JavascriptChannel(
                  name: "frontendsubscriptionOptions",
                  onMessageReceived: (JavascriptMessage message) async {
                    var msg = message.message;
                    // print("event received ${message.message}");
                    //var data = jsonDecode(message.message);

                    print('data is ${msg.toString()}');

                    String strPwd =
                        keySecret; //secret key generated in step 1 above

                    String token =
                        PushNotificationsManager.instance.token ?? '';

                    final iv = EncryptPack.IV.fromLength(16);

                    final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                    final encrypter = EncryptPack.Encrypter(
                        EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));
                    final encrypted =
                        encrypter.encrypt(token.toString(), iv: iv);
                    var hmacSha256 = CryptoPack.Hmac(
                        CryptoPack.sha256, utf8.encode(strPwd)); // HMAC-SHA256
                    var hmacstring =
                        hmacSha256.convert(utf8.encode(token.toString()));
                    var encryptedsubscription = encrypted.base64 +
                        ":" +
                        iv.base64 +
                        ":" +
                        hmacstring.toString() +
                        ":" +
                        hmacstring.toString();

                    var body = {
                      'token': encryptedsubscription,
                      "subscriptionoptions": msg.toString(),
                    };

                    var responseOfAPI = await http.post(
                      Uri.parse('$url/wp-json/PNFPBpush/v1/subscriptiontoken'),
                      body: body,
                    );
                    log(responseOfAPI.body);
                    Map<String, dynamic> fResponse =
                        json.decode(responseOfAPI.body);
                  },
                ),
                JavascriptChannel(
                  name: "messageHandler",
                  onMessageReceived: (JavascriptMessage message) async {
                    var msg = message.message;
                    // print("event received ${message.message}");
                    var data = jsonDecode(message.message);

                    var userid = data["userid"];

                    String strPwd =
                        keySecret; //secret key generated in step 1 above

                    String token =
                        PushNotificationsManager.instance.token ?? '';

                    final iv = EncryptPack.IV.fromLength(16);

                    final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                    final encrypter = EncryptPack.Encrypter(
                        EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));
                    final encrypted =
                        encrypter.encrypt(token.toString(), iv: iv);
                    var hmacSha256 = CryptoPack.Hmac(
                        CryptoPack.sha256, utf8.encode(strPwd)); // HMAC-SHA256
                    var hmacstring =
                        hmacSha256.convert(utf8.encode(token.toString()));
                    var encryptedsubscription = encrypted.base64 +
                        ":" +
                        iv.base64 +
                        ":" +
                        hmacstring.toString() +
                        ":" +
                        hmacstring.toString();
                    print('user id is $userid');
                    var body = {
                      'token': encryptedsubscription,
                      'userid': userid.toString()
                    };

                    var responseOfAPI = await http.post(
                      Uri.parse('$url/wp-json/PNFPBpush/v1/subscriptiontoken'),
                      body: body,
                    );
                    log(responseOfAPI.body);
                    Map<String, dynamic> fResponse =
                        json.decode(responseOfAPI.body);
                  },
                ),
                JavascriptChannel(
                  name: 'unsubscribeGroupid',
                  onMessageReceived: (JavascriptMessage message) async {
                    print('messa ge is ${message.message}');
                    // Here you can take message.message and use
                    // your string from webview
                    /*Fluttertoast.showToast(
                              msg: message.message.toString(),
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 25,
                              fontSize: 16.0
                          );*/

                    String strPwd = keySecret;

                    var groupid = message.message.toString();

                    final iv = EncryptPack.IV.fromLength(16);

                    final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                    final encrypter = EncryptPack.Encrypter(
                        EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));

                    final encrypted = encrypter.encrypt(
                        PushNotificationsManager.instance.token ?? '',
                        iv: iv);

                    var hmacSha256 = CryptoPack.Hmac(
                        CryptoPack.sha256, utf8.encode(strPwd)); // HMAC-SHA256

                    var hmacstring = hmacSha256.convert(utf8
                        .encode(PushNotificationsManager.instance.token ?? ''));

                    var encryptedsubscription = encrypted.base64 +
                        ":" +
                        iv.base64 +
                        ":" +
                        hmacstring.toString() +
                        ":" +
                        hmacstring.toString();

                    var url = Uri.parse(
                        '${this.url}/wp-json/PNFPBpush/v1/subscriptiontoken');

                    var response = await http.post(url, body: {
                      'token': encryptedsubscription,
                      'subscription-type': 'unsubscribe-group',
                      'groupid': groupid,
                      'cookievalue': ''
                    });

                    var outputresponse =
                        response.statusCode.toString() + ' ' + response.body;
                    log(response.body);

                    /*Fluttertoast.showToast(
                              msg: outputresponse,
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 35,
                              fontSize: 16.0
                          );*/
                  },
                ),
                JavascriptChannel(
                  name: 'subscribeGroupid',
                  onMessageReceived: (JavascriptMessage message2) async {
                    // Here you can take message.message and use
                    // your string from webview
                    /*Fluttertoast.showToast(
                              msg: message2.message.toString(),
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 15,
                              fontSize: 16.0
                          );*/

                    String strPwd = keySecret;
                    print('messa ge2 is ${message2.message}');

                    var groupid = message2.message.toString();

                    final iv = EncryptPack.IV.fromLength(16);

                    final key = EncryptPack.Key.fromUtf8(strPwd); //hardcode

                    final encrypter = EncryptPack.Encrypter(
                        EncryptPack.AES(key, mode: EncryptPack.AESMode.cbc));

                    final encrypted = encrypter.encrypt(
                        PushNotificationsManager.instance.token ?? '',
                        iv: iv);

                    var hmacSha256 = CryptoPack.Hmac(
                        CryptoPack.sha256, utf8.encode(strPwd)); // HMAC-SHA256

                    var hmacstring = hmacSha256.convert(utf8
                        .encode(PushNotificationsManager.instance.token ?? ''));

                    var encryptedsubscription = encrypted.base64 +
                        ":" +
                        iv.base64 +
                        ":" +
                        hmacstring.toString() +
                        ":" +
                        hmacstring.toString();

                    var url = Uri.parse(
                        '${this.url}/wp-json/PNFPBpush/v1/subscriptiontoken');

                    var response = await http.post(url, body: {
                      'token': encryptedsubscription,
                      'subscription-type': 'subscribe-group',
                      'groupid': groupid,
                      'cookievalue': ''
                    });

                    var outputresponse =
                        response.statusCode.toString() + ' ' + response.body;
                    log(response.body);
                    /*Fluttertoast.showToast(
                              msg: outputresponse,
                              toastLength: Toast.LENGTH_LONG,
                              gravity: ToastGravity.CENTER,
                              timeInSecForIosWeb: 35,
                              fontSize: 16.0
                          );*/
                  },
                ),
              },
              javascriptMode: JavascriptMode.unrestricted,
              initialUrl: url,
              // onProgress: (int progress) {
              //   print('WebView is loading (progress : $progress%)');
              // },
              onPageStarted: (String url) {
                //print('Page started loading: $url');
                _loading.value = true;
              },
              onPageFinished: (String url) {
                //print('Page finished loading: $url');
                _loading.value = false;
              },
            ),
            Positioned(
              child: ValueListenableBuilder<bool>(
                valueListenable: _loading,
                builder: (context, loading, _) {
                  return loading
                      ? const CircularProgressIndicator()
                      : const SizedBox();
                },
              ),
            )
          ],
        ),
      ),
    );
  }
}
