import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';
import 'package:flutter/foundation.dart';

import 'package:sample/web_viewpage.dart';
import 'package:http/http.dart' as http;
// ignore: library_prefixes
import 'package:encrypt/encrypt.dart' as EncryptPack;
import 'package:sample/push_notification_manager.dart';
// ignore: library_prefixes
import 'package:crypto/crypto.dart' as CryptoPack;

import 'home_page.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp();
  await PushNotificationsManager().init();
  var data = await FirebaseMessaging.instance.getInitialMessage();
  debugPrint('inital message is ${data?.data}');
  var newData = data?.data["click_url"];
  runApp(MyApp(
    data: newData,
  ));
  SystemChrome.setSystemUIOverlayStyle(const SystemUiOverlayStyle(
    statusBarColor: Colors.transparent,
    statusBarIconBrightness: Brightness.light, // For Android (dark icons)
    statusBarBrightness: Brightness.light,
  ));
}

final GlobalKey<NavigatorState> navigatorKey = GlobalKey<NavigatorState>();
// final GlobalKey<ScaffoldState> homeKey = GlobalKey();

class MyApp extends StatelessWidget {
  MyApp({Key? key, this.data}) : super(key: key);
  final String? data;
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: false,
      // navigatorKey: navigatorKey,
      title: 'Happy Painting',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: HomeScreen(
        url: data,
      ),
    );
  }
}

// class HomeScreen extends StatefulWidget {
//   const HomeScreen({Key? key}) : super(key: key);
//
//   @override
//   State<HomeScreen> createState() => _HomeScreenState();
// }
//
// class _HomeScreenState extends State<HomeScreen> {
//   late final InAppWebViewController _controller;
//   final ValueNotifier<bool> _loading = ValueNotifier<bool>(false);
//   @override
//   void initState() {
//     super.initState();
//   }
//
//   @override
//   Widget build(BuildContext context) {
//     return WillPopScope(
//       onWillPop: () async {
//         bool canGoBack = await _controller.canGoBack();
//         if (canGoBack) {
//           _controller.goBack();
//         }
//         return !canGoBack;
//       },
//       child: Scaffold(
//         resizeToAvoidBottomInset: false,
//         // floatingActionButton: FloatingActionButton(
//         //   onPressed: pushTokenSubmit,
//         // ),
//         body: SafeArea(
//           child: Stack(
//             alignment: Alignment.center,
//             children: [
//               InAppWebView(
//                 onWebViewCreated: (controller) {
//                   _controller = controller;
//                   _controller.addJavaScriptHandler(
//                     handlerName: 'messageHandler',
//                     callback: (args) {
//                       print('args are $args');
//                     },
//                   );
//                 },
//                 // initialFile: "assets/index.html",
//                 initialOptions: InAppWebViewGroupOptions(
//                   android: AndroidInAppWebViewOptions(
//                     useHybridComposition: true,
//                   ),
//                   ios: IOSInAppWebViewOptions(),
//                 ),
//                 onLoadStart: (_, url) {
//                   _loading.value = true;
//                   // if (url.toString() == 'https://sample.com/') {
//                   //   pushTokenSubmit();
//                   // }
//                   debugPrint('loading started ${url.toString()}');
//                 },
//                 implementation: WebViewImplementation.NATIVE,
//                 onLoadStop: (controller, __) async {
//                   _loading.value = false;
//                   var args = await controller.evaluateJavascript(
//                     source: '''messageHandler''',
//                   );
//                   print('args are $args');
//
//                   // debugPrint('loading ended');
//                 },
//                 onLoadError: (_, uri, __, error) {
//                   debugPrint('error loading ${uri?.path}, error is $error');
//                 },
//                 onProgressChanged: (_, progress) {
//                   // debugPrint('progress $progress');
//                 },
//                 initialUrlRequest: URLRequest(
//                   url: Uri.parse(
//                     'https://sample.com/',
//                   ),
//                 ),
//               ),
//               Positioned(
//                 child: ValueListenableBuilder<bool>(
//                     valueListenable: _loading,
//                     builder: (context, loading, _) {
//                       return loading
//                           ? const CircularProgressIndicator()
//                           : const SizedBox();
//                     }),
//               )
//             ],
//           ),
//         ),
//       ),
//     );
//   }
// }
